---
title: 'CSS Grid Inspector: Examine grid layouts'
slug: Tools/Page_Inspector/How_to/Examine_grid_layouts
tags:
  - Guide
  - Inspector
  - Tools
---
<div>{{ToolsSidebar}}</div>

<p class="summary">The <strong>Grid Inspector</strong> allows you to examine <a href="/en-US/docs/Web/CSS/CSS_Grid_Layout">CSS Grid Layouts</a> using the Firefox DevTools, discovering grids present on a page, examining and modifying them, debugging layout issues, and more.</p>

<div class="note">
<p><strong>Note</strong>: The examples shown in the screenshots appearing in this article are Jen Simmons' <a href="http://labs.jensimmons.com/2016/examples/futurismo-1.html">Futurismo</a> and <a href="http://labs.jensimmons.com/2017/01-003.html">Variations on a grid</a> experiments, and a <a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Grid_Template_Areas#Naming_a_grid_area">live named grid area example</a> from Rachel Andrew.</p>
</div>

<h2 id="Discovering_CSS_grids">Discovering CSS grids</h2>

<p>When an HTML element on your page has <code><a href="/en-US/docs/Web/CSS/display">display: grid</a></code> applied to it, a number of features are made available in the DevTools to provide easy access to grid features.</p>

<h3 id="In_the_HTML_pane">In the HTML pane</h3>

<p>In the <a href="/en-US/docs/Tools/Page_Inspector/UI_Tour#HTML_pane">HTML Pane</a>, elements laid out using a grid have a "grid" marker beside them.</p>

<p><img alt="The HTML pane of the Firefox devtools, showing an element annotated with a grid marker, meaning that it has display: grid set on it" src="https://mdn.mozillademos.org/files/15977/html-pane.png" style="border-style: solid; border-width: 1px; display: block; height: 262px; margin: 0px auto; width: 400px;"></p>

<h3 id="In_the_CSS_pane">In the CSS pane</h3>

<p>In the <a href="/en-US/docs/Tools/Page_Inspector/UI_Tour#CSS_pane">CSS pane</a>'s Rules view, any instance of a <code><a href="/en-US/docs/Web/CSS/display">display: grid</a></code> declaration gets a grid icon included within it: <img alt="" src="https://mdn.mozillademos.org/files/14524/Screen%20Shot%202016-12-16%20at%2010.51.15%20AM.png" style="height: 22px; margin-bottom: -5px; width: 22px;">.</p>

<p><img alt="The CSS pane of the Firefox devtools, showing the CSS for a grid layout with a grid icon included next to display: grid" src="https://mdn.mozillademos.org/files/15978/css-pane.png" style="border-style: solid; border-width: 1px; display: block; height: 399px; margin: 0px auto; width: 1146px;"></p>

<p>Clicking the icon toggles the display of a grid overlay on the page, which appears over the element, laid out like a grid to show the position of its grid lines and tracks:</p>

<p><img alt="A screenshot of the Firefox web browser, showing a colored overlay on top of a section of the page laid out like a grid " src="https://mdn.mozillademos.org/files/15979/grid-overlay.png" style="border-style: solid; border-width: 1px; display: block; height: 1383px; margin: 0px auto; width: 1842px;"></p>

<p>The overlay is still shown when you select other elements, so you can edit related CSS properties and see how the grid is affected.</p>

<h3 id="The_Layout_view_Grid_section">The Layout view Grid section</h3>

<p>When grids are included on a page, the CSS pane's Layout view includes a "Grid" section containing a number of options for viewing those Grids. You can find out more about those in the section below.</p>

<div class="note">
<p><strong>Note</strong>: The Layout view can be found underneath the <em>Layout</em> tab on the right-hand pane of the Page Inspector. The above and below screenshots should give you further hints on how to get to this.</p>
</div>

<h2 id="Grid_options">Grid options</h2>

<p>The Grid section of the Layout view looks like this:</p>

<p><img alt="The grid options section of the Firefox devtools Layout view, showing multiple options for specifying how you want to see CSS grids displayed" src="https://mdn.mozillademos.org/files/15980/grid-options.png" style="border-style: solid; border-width: 1px; display: block; height: 408px; margin: 0px auto; width: 500px;"></p>

<p>You'll see a number of options contained within:</p>

<ul>
 <li>Overlay Grid: Contains a checkbox for each grid present on the page, along with various options. Allows overlay views to be toggled on and off.</li>
 <li>Grid Display Settings:
  <ul>
   <li>Display line numbers: Turn the line numbers shown for each grid overlay on and off (on by default).</li>
   <li>Display area names: Turn area names on and off, in the case of grids with named grid areas (on by default, where relevant).</li>
   <li>Extend lines infinitely: By default, grid lines/tracks are only shown inside the element with <code>display: grid</code> set on it; when toggling this option on, the grid lines extend to the edge of the viewport along each axis.</li>
  </ul>
 </li>
 <li>Mini grid view: A smaller view of the currently overlaid grid.</li>
</ul>

<div class="note">
<p><strong>Note</strong>: Your grid preferences such as overlay color and display settings choices are persisted across page loads for each separate page.</p>
</div>

<p>Let's examine these features in more detail.</p>

<h3 id="Overlay_grid">Overlay grid</h3>

<p>Each grid present on a page has an entry in the "Overlay grid" section:</p>

<p><img alt="An entry for a single grid in the Overlay Grid section of the Grid options, showing a grid's name, overlay color, and more." src="https://mdn.mozillademos.org/files/15981/overlay-grid-entry.png" style="border-style: solid; border-width: 1px; display: block; height: 37px; margin: 0px auto; width: 300px;"></p>

<p>Each entry consists of (from left to right):</p>

<ul>
 <li>A checkbox allowing you to toggle the grid overlay for that grid on and off.</li>
 <li>A name label to represent the grid, consisting of a selector identifying the HTML element that has the grid applied to it. Clicking this also toggles the grid overlay on and off.</li>
 <li>A target icon that when clicked immediately selects the HTML element that this grid entry relates to, inside the HTML pane.</li>
 <li>A color picker icon that allows you to change the primary color of the grid overlay. This is useful for selecting different colors so you can easily tell your grids apart.</li>
</ul>

<h3 id="Inspecting_a_subgrid">Inspecting a subgrid</h3>

<p>When the page contains a grid with a subgrid, the entry for the subgrid is indented under its parent in the Overlay grid section. When you select the checkbox for the subgrid, the lines for the parent grid are displayed also displayed; if the checkbox for the parent grid is unselected, then its lines are translucent.</p>

<p><img alt="Screenshot showing the overlay lines for a subgrid, with the subgrid lines and parent grid lines called out." src="https://mdn.mozillademos.org/files/17064/subgrid-lines.png" style="height: 791px; width: 709px;"></p>

<h3 id="Display_line_numbers">Display line numbers</h3>

<p>By default, the line numbers are displayed on the grid overlay.</p>

<p><img alt="A CSS grid overlay with grid line numbers displayed" src="https://mdn.mozillademos.org/files/15982/line-numbers.png" style="border-style: solid; border-width: 1px; display: block; height: 582px; margin: 0px auto; width: 600px;"></p>

<p>Unchecking the "Display line numbers" box turns them off.</p>

<p><img alt="A CSS grid overlay with grid line numbers not displayed" src="https://mdn.mozillademos.org/files/15983/no-line-numbers.png" style="border-style: solid; border-width: 1px; display: block; height: 580px; margin: 0px auto; width: 600px;"></p>

<h3 id="Display_area_names">Display area names</h3>

<p>In a grid with named areas, the area names are shown on the grid overlay by default.</p>

<p><img alt="A CSS grid overlay with named area names displayed" src="https://mdn.mozillademos.org/files/15984/grid-named-areas.png" style="border-style: solid; border-width: 1px; display: block; height: 777px; margin: 0px auto; width: 1396px;"></p>

<p>Unchecking the "Display area names" box turns them off.</p>

<p><img alt="A CSS grid overlay with named area names not displayed" src="https://mdn.mozillademos.org/files/15990/no-grid-named-areas.png" style="border-style: solid; border-width: 1px; display: block; height: 788px; margin: 0px auto; width: 1400px;"></p>

<h3 id="Extend_lines_infinitely">Extend lines infinitely</h3>

<p>By default, the grid lines/tracks are only shown inside the element with <code>display: grid</code> set on it.</p>

<p><img alt="A CSS grid overlay with grid lines not extended infinitely" src="https://mdn.mozillademos.org/files/15987/no-extend-lines.png" style="border-style: solid; border-width: 1px; display: block; height: 499px; margin: 0px auto; width: 1000px;"></p>

<p>When you check the "Extend lines infinitely" option, the grid lines extend to the edge of the viewport along each axis.</p>

<p><img alt="A CSS grid overlay with grid lines extended infinitely" src="https://mdn.mozillademos.org/files/15986/extend-lines.png" style="border-style: solid; border-width: 1px; display: block; height: 501px; margin: 0px auto; width: 1000px;"></p>

<h3 id="Mini_grid_view">Mini grid view</h3>

<p>Shows a small version of the currently overlaid grid, which is in proportion to the real thing.</p>

<p><img alt="A mini CSS grid view from the Firefox DevTools" src="https://mdn.mozillademos.org/files/15988/mini-grid-view.png" style="border-style: solid; border-width: 1px; display: block; height: 246px; margin: 0px auto; width: 600px;"></p>

<p>Hovering over the different areas of the mini grid causes the equivalent area on the grid overlay to also highlight, along with a tooltip containing useful information such as the dimensions of that area, its row and column numbers, etc.</p>

<p><img alt="A firefox screenshot showing an area of a mini CSS grid being highlighted in the DevTools, and the corresponding area in the real grid being highlighted on the web page." src="https://mdn.mozillademos.org/files/15989/mini-grid-highlight.png" style="border-style: solid; border-width: 1px; display: block; height: 793px; margin: 0px auto; width: 1200px;"></p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="http://labs.jensimmons.com/">labs.jensimmons.com</a> — lots of interesting grid examples.</li>
 <li><a href="https://gridbyexample.com/">Grid by Example</a> — CSS Grid learning resources from Rachel Andrew.</li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout">CSS Grid Layout</a> — MDN CSS Grid Layout references and tutorials.</li>
</ul>
